ocserv/tests/json
Nikos Mavrogiannopoulos bc4b1c5f12 tests: auto-generate random addresses instead of hard-coding them
The main benefit is that there is less manual work to add a
test (discovery of unique random addresses is not necessary),
but it also ensures that the tests can run on environments where the
previously hard-coded addresses were present.

Signed-off-by: Nikos Mavrogiannopoulos <n.mavrogiannopoulos@gmail.com>
2023-12-29 21:18:28 +01:00

186 lines
4.1 KiB
Bash
Executable File

#!/bin/bash
#
# Copyright (C) 2018 Nikos Mavrogiannopoulos
#
# This file is part of ocserv.
#
# ocserv is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# ocserv is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
OCCTL="${OCCTL:-../src/occtl/occtl}"
SERV="${SERV:-../src/ocserv}"
srcdir=${srcdir:-.}
PIDFILE=ocserv-pid.$$.tmp
CLIPID=oc-pid.$$.tmp
PATH=${PATH}:/usr/sbin
IP=$(which ip)
OUTFILE=json.$$.tmp
. `dirname $0`/common.sh
eval "${GETPORT}"
if test -z "${IP}";then
echo "no IP tool is present"
exit 77
fi
if test "$(id -u)" != "0";then
echo "This test must be run as root"
exit 77
fi
echo "Testing ocserv connection via haproxy... "
function finish {
set +e
echo " * Cleaning up..."
test -n "${PID}" && kill ${PID} >/dev/null 2>&1
test -n "${PIDFILE}" && rm -f ${PIDFILE} >/dev/null 2>&1
test -n "${CLIPID}" && kill $(cat ${CLIPID}) >/dev/null 2>&1
test -n "${CLIPID}" && rm -f ${CLIPID} >/dev/null 2>&1
test -n "${CONFIG}" && rm -f ${CONFIG} >/dev/null 2>&1
rm -f ${OUTFILE} 2>&1
}
trap finish EXIT
# server address
OCCTL_SOCKET=./occtl-json-$$.socket
USERNAME=test
. `dirname $0`/random-net.sh
. `dirname $0`/ns.sh
# Run servers
update_config test-traffic.config
if test "$VERBOSE" = 1;then
DEBUG="-d 3"
fi
${CMDNS2} ${SERV} -p ${PIDFILE} -f -c ${CONFIG} ${DEBUG} & PID=$!
sleep 4
echo " * Connecting to ${ADDRESS}:${PORT}..."
( echo "test" | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} --passwd-on-stdin -b )
if test $? != 0;then
echo "Could not connect to server"
exit 1
fi
set -e
echo " * ping remote address"
${CMDNS1} ping -c 3 ${VPNADDR}
set +e
${OCCTL} -s ${OCCTL_SOCKET} --json show users >${OUTFILE}
if test $? != 0;then
echo "occtl show users failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show users json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json --debug show users >${OUTFILE}
if test $? != 0;then
echo "occtl show users --debug failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show users --debug json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json show user ${USERNAME} >${OUTFILE}
if test $? != 0;then
echo "occtl show user failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show user json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json --debug show user ${USERNAME} >${OUTFILE}
if test $? != 0;then
echo "occtl show user --debug failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show user --debug json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json show status >${OUTFILE}
if test $? != 0;then
echo "occtl show status failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show status json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json --debug show status >${OUTFILE}
if test $? != 0;then
echo "occtl show status --debug failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show status --debug json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json show session all >${OUTFILE}
if test $? != 0;then
echo "occtl show session all failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show session all json invalid"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} --json --debug show session all >${OUTFILE}
if test $? != 0;then
echo "occtl show session all --debug failed!"
exit 1
fi
json_verify <${OUTFILE}
if test $? != 0;then
echo "occtl show session all --debug json invalid"
exit 1
fi
exit 0